//
//   eye.c:  Eye Cheker for Pilot
// 
//   Yasushi Soda 
//   Mar. 1998
//   soda@sainet.or.jp
//

#pragma pack(2)

#include <Common.h>
#include <System/SysAll.h>
#include <UI/UIAll.h>
#include <KeyMgr.h>
#include <SysEvtMgr.h>
#include "eye.h"

static int StartApplication(void);
static void EventLoop(void);
static void StopApplication(void);
static Boolean title(EventPtr event);
static Boolean game(EventPtr event);

static void BitmapDraw(Word BitmapID,int x,int y);
static void RingDraw(int Ran,int Tb);
static void MsgDraw(int Tb);

int Tb = 5;
int OKCnt=0;
int NGCnt=0;
int Ran = 0;

// Bitmap Size
int BSize[]={3,5,10,15,20,25};


DWord  PilotMain (Word cmd, Ptr cmdPBP, Word launchFlags)
{
  int error;

  if (!cmd)
  {
    error = StartApplication();	// Application start code
    if (error) return error;

    EventLoop();	// Event loop

    StopApplication ();	// Application stop code
  }
  return 0;
}

static int StartApplication(void)
{
  int error;

  FrmGotoForm(TitleForm);   // go to title form
}

static void EventLoop(void)
	{
  	short err;
  	int formID;
  	FormPtr form;
  	EventType event;

  	do
  		{

    	EvtGetEvent(&event, 100);

    	if (SysHandleEvent(&event)) continue;
    	if (MenuHandleEvent((void *)0, &event, &err)) continue;

    	if (event.eType == frmLoadEvent)
    		{
      		formID = event.data.frmLoad.formID;
      		form = FrmInitForm(formID);
      		FrmSetActiveForm(form);
      		switch (formID) 
      			{	
	       		case TitleForm:
         			FrmSetEventHandler(form, (FormEventHandlerPtr) title);
        			break;
	  			case GameForm:
        			FrmSetEventHandler(form, (FormEventHandlerPtr) game);
        			break;
      			}
			}
			FrmDispatchEvent(&event);
  	
    	} while(event.eType != appStopEvent);
    	
}

static void StopApplication(void)
	{

	}

static Boolean game(EventPtr event)
{
	FormPtr   form;
	RectangleType dstRect;
  	int  handled = 0;
  	short err;
	int i,j,k;
	DWord key_Data;
	int	over_flg;
	int Dirct,DirctKey;

  switch (event->eType) 
  {
	case frmLoadEvent:
	    handled = 1;
  		break;

  	case frmOpenEvent:
 	   	form = FrmGetActiveForm();
    	FrmDrawForm(form);
    	 	
		Tb = 5;
		over_flg = 0;
		OKCnt = 0;
		NGCnt = 0;

		do {
			
			RingDraw(Ran,Tb);
			Dirct = Ran;
			key_Data = 0;
			EvtFlushKeyQueue();
			do {
				Ran++;
				if (Ran > 3) Ran = 0; 
				key_Data = KeyCurrentState();
				EvtFlushKeyQueue();

			} while(key_Data == 0);
	
			DirctKey = -1;
			switch (key_Data) 
   			{	
  			case 0x01:
				over_flg = 1;
				break;
			case 0x02:
				DirctKey = 0;
				break;
			case 0x04:
				DirctKey = 1;
				break;
			case 0x20:
				DirctKey = 2;
				break;
			case 0x10:
				DirctKey = 3;
				break;
			}

			if (Dirct == DirctKey) OKCnt ++;
			else	NGCnt ++;

			if (OKCnt >= 2) { 
				Tb --;
				OKCnt = 0;
				NGCnt = 0;
				if (Tb < 0) {	
					Tb  = 0;
					over_flg = 1;
				}
			}
			
			if (NGCnt >= 2) {
				Tb ++;
				OKCnt = 0;
				NGCnt = 0;
				if (Tb > 5)	{
					Tb  = 5;
				}
				over_flg = 1;
			}


		} while(over_flg == 0);

		EvtFlushKeyQueue();

		MsgDraw(Tb);

		EvtFlushKeyQueue();
		do {
			key_Data = KeyCurrentState();
			EvtFlushKeyQueue();
		} while(key_Data == 0);

		FrmGotoForm(TitleForm);

   		handled = 1;
   		break;

  case ctlSelectEvent:  // A control button was pressed and released.
    break;
 

  case nilEvent:

    break;
  }
  return handled;
}

static Boolean title(EventPtr event)
{
  FormPtr   form;
  int       handled = 0;
  short err;

  switch (event->eType) 
  {

  case frmOpenEvent:
    form = FrmGetActiveForm();
    FrmDrawForm(form);
    handled = 1;
    break;
    
  case ctlSelectEvent:  // A control button was pressed and released.

    if (event->data.ctlEnter.controlID== StartBtn)
    {
      FrmGotoForm(GameForm);
      handled = 1;
    }
    break;

  case nilEvent:
	Ran++;
	if (Ran > 3) Ran = 0; 
    break;
  }
  return handled;
}


static void BitmapDraw(Word BitmapID,int x,int y)
{
	BitmapPtr	resP;
	VoidHand	resH;
	resH = DmGet1Resource('Tbmp',BitmapID);
	resP = MemHandleLock(resH);
	WinDrawBitmap (resP,x,y);
	resP = MemHandleUnlock(resH);
	DmReleaseResource(resH);
}

static void RingDraw(int Ran,int Tb)
{
	int x,y,i,j;
	RectangleType dstRect;
	
	dstRect.topLeft.x = 50 - 50/2;
	dstRect.topLeft.y = 80 - 50/2;
	dstRect.extent.x = 50;
	dstRect.extent.y = 50;
	WinFillRectangle(&dstRect,0);

	for(i = 0;i<30000;i++){
		for (j=0;j<20;j++){}
	}
	WinEraseRectangle(&dstRect,0);

	x = 50 - BSize[Tb]/2;
	y = 80 - BSize[Tb]/2;
	BitmapDraw(B0up + Tb * 10 + Ran, x, y);
}

static void MsgDraw(int Tb)
{
	int i,j;

	switch(Tb){
	case 0:
		WinDrawChars("łBƘVႬ݂",StrLen("łBƘVႬ݂"),10,140);
		break;
	case 1:
		WinDrawChars("ȂłB",StrLen("ȂłB"),10,140);
		break;
	case 2:
		WinDrawChars("ڂłˁBږłB",StrLen("ڂłˁBږłB"),10,140);
		break;
	case 3:
		WinDrawChars( "BoldtHgłˁB",StrLen("BoldtHgłˁB"),10,140);
		break;
	case 4:
		WinDrawChars("Ct悤BpilotȂȂ",StrLen("Ct悤BpilotȂȂ"),10,140);
		break;
	case 5:
		WinDrawChars( "v߂˂łB",StrLen( "v߂˂łB"),10,140);
		break;
	}
	for(i = 0;i<30000;i++){
		for (j=0;j<20;j++){}
	}
}

